/*
 * Copyright (c) 2012, IDM
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright notice, this list of
 *       conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright notice, this list
 *       of conditions and the following disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 *     * Neither the name of the IDM nor the names of its contributors may be used to endorse or
 *       promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#import "SkPublishAPIAppDelegate.h"

#import "SkPublishAPIViewController.h"

#import "SkPublishAPI.h"
#import "RequestHandler.h"
#import "MyRequestHandler.h"

@implementation SkPublishAPIAppDelegate

@synthesize window = _window;
@synthesize viewController = _viewController;

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    NSMutableString *outputRes1 = [self run];
    setenv("API_ACCEPT", "application/xml", 1);

    NSMutableString *outputRes2 = [self run];
    [outputRes1 appendString:outputRes2];

    _viewController.txtApiResults.text = outputRes1;

    return YES;
}

-(NSMutableString*)run
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        self.viewController = [[[SkPublishAPIViewController alloc] initWithNibName:@"SkPublishAPIViewController_iPhone" bundle:nil] autorelease];
    } else {
        self.viewController = [[[SkPublishAPIViewController alloc] initWithNibName:@"SkPublishAPIViewController_iPad" bundle:nil] autorelease];
    }
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        self.viewController = [[[SkPublishAPIViewController alloc] initWithNibName:@"SkPublishAPIViewController_iPhone" bundle:nil] autorelease];
    } else {
        self.viewController = [[[SkPublishAPIViewController alloc] initWithNibName:@"SkPublishAPIViewController_iPad" bundle:nil] autorelease];
    }
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];


    // start skPublishAPI requests

    MyRequestHandler *requestHandler = [[MyRequestHandler alloc] init];

    NSString *url = @"http://myskpublishsite.mydomain.com/api/v1";
    NSString *accessKey = @"myacckeymyacckeymyacckeymyacckeymyacckeymyacckeymyacckeymyacckey";

    SkPublishAPI *api = [[SkPublishAPI alloc] initWithUrlAndAcessKey : url : accessKey ];
    [api setRequestHandler: requestHandler];


    NSString *result;
    NSString *day = @"1212";
    NSString *format = @"html";

    NSMutableString *outputRes = [[NSMutableString alloc] init];
    [requestHandler setOutputRes: outputRes];


    NSLog(@"*** Dictionaries");

    result = [api getDictionaries];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getDictionary:@"uk"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getDictionary:@"us"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];
    NSLog(@"*** Entry");

    result = [api getEntry:@"uk" : @"cab" : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getEntry:@"us" : @"pâté" : @"xml"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getEntry:@"us" : @"#" : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Pronounciations");

    result = [api getEntryPronunciations:@"us" : @"pâté": NULL];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getEntryPronunciations:@"us" : @"go" : @"uk"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Nearby Entries");

    result = [api getNearbyEntries:@"us" : @"care": NULL];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getNearbyEntries:@"us" : @"care": [NSNumber numberWithInt:2]];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Related Entries");

    result = [api getRelatedEntries:@"uk" : @"coin"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Word of the Day");

    result = [api getWordOfTheDay:NULL : NULL : NULL];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDay:NULL : NULL : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDay:NULL : day : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDay:@"uk" : day : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDay:@"us" : day : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Word of the Day Preview");

    result = [api getWordOfTheDayPreview: NULL : NULL];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDayPreview:NULL : day];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDayPreview:@"uk" : day];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getWordOfTheDayPreview:@"us" : day];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    NSLog(@"*** Searches");

    result = [api search:@"uk" : @"ca?" : [NSNumber numberWithInt:1] : [NSNumber numberWithInt:2]];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api searchFirst:@"uk" : @"ca?" : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api search:@"us" : @"ca?" : [NSNumber numberWithInt:1] : [NSNumber numberWithInt:2]];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api searchFirst:@"us" : @"ca?" : format];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getThesaurusList:@"british"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getTopic:@"british":@"topics" : NULL];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api getTopic:@"british":@"topics" : @"cars"];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    result = [api didYouMean:@"british" : @"dorg" : [NSNumber numberWithInt:2]];
    NSLog(@"%@", result);
    [outputRes appendString:[NSString stringWithFormat:@"%@\n", result]];

    return outputRes;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.    
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
